//      
#property script_show_inputs

#include <fxsaber\Expert.mqh>

input bool CurrentChart = false; //    (true)/(false) 

string GetMyName( void )
{
  return(StringSubstr(MQLInfoString(MQL_PROGRAM_PATH), StringLen(TerminalInfoString(TERMINAL_DATA_PATH) + "\\MQL5\\")));
}

bool RunExpert( const long Chart )
{
  MqlParam Params[2];

  //   
  Params[0].string_value = "Experts\\Advisors\\ExpertMACD.ex5";

  //    
  Params[1].type = TYPE_STRING;
  Params[1].string_value = "Hello World!";

  return(EXPERT::Run(Chart, Params));
}

#define NAME __FILE__

void OnStart()
{
  union UNION
  {
    double Double;
    long Long;
  } Chart;

  if (CurrentChart)
  {
    Chart.Long = ChartID();
    GlobalVariableSet(NAME, Chart.Double);

    MqlParam Params[1];

    //    ()
    Params[0].string_value = GetMyName();

    //     
    EXPERT::Run(ChartOpen(_Symbol, _Period), Params);
  }
  else if (GlobalVariableCheck(NAME))
  {
    Chart.Double = GlobalVariableGet(NAME);
    GlobalVariableDel(NAME);

    RunExpert(Chart.Long);

    ChartClose();
  }
  else //     (   -)    
    RunExpert(ChartOpen(_Symbol, _Period));
}